<?php
defined('_JEXEC') or die('Restricted access');
jimport('joomla.plugin.helper');

class plgJshoppingCheckoutAddon_extra_checkbox extends JPlugin{
    function __construct(&$subject, $config){
        parent::__construct($subject, $config);
    }
    
    function onBeforeDisplayCheckoutStep2View(&$view){
        $addon_config = $this->getAddonParams();
        if ($addon_config['extra_checkbox_text']){
            $view->_tmpl_address_html_4 .= 
            '<div class="extra_checkbox"> 
                <div class="control-group">
                    <div class="control-label name">
                        <label for="extra_checkbox">'.$addon_config['extra_checkbox_text'].'</label>
                    </div>
                    <div class="controls">
                        <input id="extra_checkbox" type = "checkbox" name = "extra_checkbox" value="1"/>
                    </div>
                </div>
            </div>';
        }
    }
    
    function onBeforeSaveCheckoutStep2(&$adv_user, &$user, &$cart){
        $extra_checkbox = \JFactory::getApplication()->input->getInt('extra_checkbox');
        $addon_config = $this->getAddonParams();
        if ($extra_checkbox) {
            $session = \JFactory::getSession();
            $session->set("extra_checkbox", "1");
        }
        if ($addon_config['required'] && !$extra_checkbox){
            \JSError::raiseWarning('', $addon_config['extra_checkbox_text']." "._JSHOP_REQUIRED);
            $app = \JFactory::getApplication();          
            $app->redirect(\JSHelper::SEFLink('index.php?option=com_jshopping&controller=checkout&task=2', 1));            
        }
    }

    function onBeforeDisplayCheckoutStep5View(&$view){
        $addon_config = $this->getAddonParams();
        \JSFactory::loadExtLanguageFile('addon_extra_checkbox');
        if ($addon_config['confirm_delivery_email']){
            $text = sprintf(_JSHOP_CONFIRM_DELIVERY_EMAIL_TEXT, $view->sh_method->name, $view->sh_method->name);
            
            if ($addon_config['confirm_delivery_email_required']) {
                $required = 'required';
            } else {
                $required = '';
            }
            $view->_tmp_ext_html_previewfinish_agb .=
                '<div class="extra_checkbox"> '
              . '<input type="checkbox" name="confirm_delivery_email" id="confirm_delivery_email" value="1" '.$required.'> '
              . '<label for="confirm_delivery_email" style="display:inline;">'.$text.'</label>'
              . '</div>';
        }
        if ($addon_config['confirm_check_3']){
            $text = _JSHOP_EXTRA_CHECKBOX_3_TEXT;
            $view->_tmp_ext_html_previewfinish_agb .=
                '<div class="extra_checkbox"> '
              . '<input type="checkbox" name="confirm_check_3" id="confirm_check_3" value="1"> '
              . '<label for="confirm_check_3" style="display:inline;">'.$text.'</label>'
              . '</div>';
        }
    }

    function onBeforeCreateOrder(&$order, &$cart, &$model){		
        $order->confirm_check_1 = (int)\JFactory::getSession()->get("extra_checkbox");
        $order->confirm_delivery_email = \JFactory::getApplication()->input->getInt('confirm_delivery_email');
        $order->confirm_check_3 = \JFactory::getApplication()->input->getInt('confirm_check_3');
		
		\JFactory::getSession()->clear('extra_checkbox');
    }

    private function getAddonParams(){
        $addon = \JSFactory::getTable('addon', 'jshop');
        $addon->loadAlias('addon_extra_checkbox');
        return $addon->getParams();
    }
}